(function ($, undefined) {
	$(document).ready(function() {
		var pinId = 0;
		var dragging=false, initial=false, dragTarget=0, ix,iy, ex, ey;
		var pins = new Array();
		
		function L() {
			this.id = 'pin-'+pinId;
			this.el = $('#'+this.id);
			this.title;
			this.main_heading;
			this.sub_heading;
			this.address;
			this.phone;
			this.content;
			this.x;
			this.y;
			this.deleted = false;
		}
		
		$('.pin-holder').on('mousedown', function(e) {
			e.preventDefault();
			$('body').prepend(pinHtml());
			$('#pin-'+pinId).css({
				"position" : 'absolute',
				"left" : e.pageX,
				"top" : e.pageY + 30,
			});
			pins['pin-'+pinId] = new L();
			ix = e.pageX;
			iy = e.pageY + 30;
			ex = e.pageX;
			ey = e.pageY;
			dragging = true;
			dragTarget = $('#pin-'+pinId);
			pinId++;
			
			return false;
		});
		$(document).on('mousemove', function(e) {
			if (dragging) {
				e.preventDefault();
				dragTarget.css({
					"left" : ix - ex + e.pageX,
					"top" : iy - ey + e.pageY
				});
			}
			return false;
		});
		$(document).on('mouseup', function(e) {
			if (dragging) {
				dragging = false;
				
				updateCoords(dragTarget);
				
				if (!dragTarget.data('init')) {
					dragTarget.data({
						"init" : true,
						"x" : dragTarget.offset().left - $('.map').offset().left,
						"y" : dragTarget.offset().top - $('.map').offset().top
					});
					appendContents(dragTarget);
					$(dragTarget).find('.close').on('click', function() {
						$(this).closest('.pin-wrap').removeClass('selected');
					});
					
					$(dragTarget).find('.pin').on('click', function() {
						e.preventDefault();
						$('.selected').removeClass('selected');
						$(this).parent().addClass('selected');
						updateForm();
						return false;
					});
					$(dragTarget).on('mousedown', function(e) {
						e.preventDefault();
						dragging = true;
						dragTarget = $(this);
						ix = dragTarget.offset().left;
						iy = dragTarget.offset().top;
						ex = e.pageX;
						ey = e.pageY;
						return false;
					});
					
					$(dragTarget).find('.pin-contents').css({
						"top" : -$(dragTarget).find('.pin-contents').height() - 80
					});
				}
			}
		});
		$(document).on('keyup', function(e) {
			if (e.which == 46 && $('.pin-wrap.selected').length != 0) {
				var id = $('.selected').attr('id');
				pins[id].deleted = true;
				pins[id].el.remove();
			}
		});
		
		$('input').add('form textarea').on('change', function() {
			if ($('.pin-wrap.selected').length != 0) {
				updateData();
			}
		});
		$('.build').on('click', function() {
			$('#result').html(result());
		});
		
		function result() {
			var html='';
			
			html += "<div id=\"rockstar-map\">\n";
			var pin;

			for (var i=0; i<pinId; i++) {
				pin = pins['pin-'+i];
												  html += "\t<div class=\"location\" id=\"loc-"+i+"\" data-title=\""+pin.title+"\" data-x=\""+pin.x+"\" data-y=\""+pin.y+"\">\n";
				if (pin.main_heading != undefined) 	{ html += "\t\t<h1>"+pin.main_heading+"</h1>\n"; }
				if (pin.sub_heading != undefined) 		{ html += "\t\t<h2>"+pin.sub_heading+"</h2>\n"; }
				if (pin.address != undefined) 			{ html += "\t\t<p class=\"address\">"+pin.address+"</p>\n"; }
				if (pin.phone != undefined) 			{ html += "\t\t<p class=\"phone\">"+pin.phone+"</p>\n"; }
				if (pin.content != undefined) 			{ html += "\t\t<p class=\"content\">"+pin.content+"</p>\n"; }
												  html += "\t</div>\n";
			}
			
			html += "</div>";
			
			return html;
		}
		function updateForm() {
			var id = $('.selected').attr('id');
			$('#title').val(pins[id].title);
			$('#main_heading').val(pins[id].main_heading);
			$('#sub_heading').val(pins[id].sub_heading);
			$('#address').val(pins[id].address);
			$('#phone').val(pins[id].phone);
			$('#content').val(pins[id].content);
		}
		function updateCoords(el) {
			var id = el.attr('id');
			
			pins[id].x = pins[id].el.offset().left - $('.map').offset().left;
			pins[id].y = pins[id].el.offset().top - $('.map').offset().top;
		} 
		function updateData() {
			var id = $('.selected').attr('id');
			pins[id].title = $('#title').val();
			pins[id].main_heading = $('#main_heading').val();
			pins[id].sub_heading = $('#sub_heading').val();
			pins[id].address = $('#address').val();
			pins[id].phone = $('#phone').val();
			pins[id].content = $('#content').val();
			
			$('.selected').find('h1').html(pins[id].main_heading);
			$('.selected').find('h2').html(pins[id].sub_heading);
			$('.selected').find('.address').html(pins[id].address);
			$('.selected').find('.phone').html(pins[id].phone);
			$('.selected').find('.content').html(pins[id].content);
			
			if (pins[id].main_heading == '') {
				$('.selected').find('h1').hide();
			} else { 
				$('.selected').find('h1').show(); 
			}
			
			if (pins[id].sub_heading == '') {
				$('.selected').find('h2').hide();
			} else { 
				$('.selected').find('h2').show(); 
			}
			
			if (pins[id].address == '') {
				$('.selected').find('.address').hide();
			} else { 
				$('.selected').find('.address').show(); 
			}
			
			if (pins[id].phone == '') {
				$('.selected').find('.phone').hide();
			} else { 
				$('.selected').find('.phone').show(); 
			}
			
			if (pins[id].content == '') {
				$('.selected').find('.content').hide();
			} else { 
				$('.selected').find('.content').show(); 
			}
			
			$('.selected').find('.pin-contents').css({
				"top" : -$('.selected').find('.pin-contents').height() - 80
			});
		}
		function pinHtml() {
			var ph='';

			ph += '<div class="pin-wrap" id="pin-'+pinId+'">';
			ph += 	'<div class="pin"></div>';
			ph += '</div>';
			
			return ph;
		}
		function appendContents(pin) {
			var ph='';
			ph += 	'<div class="pin-contents">';
			ph += 		'<div class="edit"><a href="#myform"></a></div>';
			ph += 		'<div class="close"></div>';
			ph += 		'<h1></h1>';
			ph += 		'<h2></h2>';
			ph += 		'<p class="address">13 Random Str. 9000<br />Second line address</p>';
			ph += 		'<p class="phone">+359 876 122011<br />+359 882 109953<br />+359 872 121010</p>';
			ph += 		'<p class="content">';
			ph += 		'	Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.';
			ph += 		'</p>';
			ph += 	'</div>';
			pin.append(ph);
		}
		function isWithinArea(x, y, a) {
			if ((x > a.offset().left && x < a.offset().left + a.width()) &&
				(y > a.offset().top && y < a.offset().top + a.height())) {
				return true;
			}
			return false;
		}
	});
}(jQuery));