(function ($, undefined) {
	$(document).ready(function() {
		var pinId = 0;
		var dragging=false, initial=false, dragTarget=0, ix,iy, ex, ey;
		var mapLeft = $('.pins').offset().left;
		var mapTop = $('.pins').offset().top;
		var pins = new Array();
		var mapWidth, mapHeight, mapActualWidth, mapActualHeight, ratio;
		
		var map = new Image();
		$(map).attr('src', $('.map').attr('src'));
		map.onload = function() {
			mapWidth = map.width;
			mapHeight = map.height;	
			mapActualWidth = $('.map').width();
			mapActualHeight = $('.map').height();
			
			ratio = mapActualWidth / mapWidth;
			
			load_pins();
		}
		
		function L() {
			this.id = 'pin-'+pinId;
			this.el = $('#'+this.id);
			this.title;
			this.main_heading;
			this.sub_heading;
			this.address;
			this.phone;
			this.content;
			this.x;
			this.y;
			this.deleted = false;
		}
		
		$('.pin-holder').on('mousedown', function(e) {
			e.preventDefault();
			$('.pins').prepend(pinHtml());
			$('#pin-'+pinId).css({
				"position" : 'absolute',
				"left" : e.pageX - mapLeft,
				"top" : e.pageY + 30 - mapTop,
			});
			pins['pin-'+pinId] = new L();
			ix = e.pageX - mapLeft;
			iy = e.pageY + 30 - mapTop;
			ex = e.pageX;
			ey = e.pageY;
			dragging = true;
			dragTarget = $('#pin-'+pinId);
			pinId++;
			
			return false;
		});
		$(document).on('mousemove', function(e) {
			if (dragging) {
				e.preventDefault();
				dragTarget.css({
					"left" : ix - ex + e.pageX,
					"top" : iy - ey + e.pageY
				});
			}
			return false;
		});
		$(document).on('mouseup', function(e) {
			if (dragging) {
				dragging = false;
				
				if (!dragTarget.data('init')) {
					dropPinToMap(dragTarget, e);
				}
				
				updateCoords(dragTarget);
			}
		});
		
		$('input').add('form textarea').on('change', function() {
			if ($('.pin-wrap.selected').length != 0) {
				updateData();
			}
			$('#result').html(result());
		});
		$('input[type="submit"]').on('click', function() {
			$('#result').html(result());
		});
		
		function load_pins() {
			var loaded_pins = $('.hiddenresult').find('.location');
			var l = loaded_pins.length;
			var loadedPin, pin;

			for (var i=0; i<l; i++) {
				$('.pins').prepend(pinHtml());
				
				var pinEl = $('#pin-'+pinId);
				
				pin = new L();
				loadedPin = $(loaded_pins[i]);
				
				pin.title = loadedPin.attr('data-title');
				pin.main_heading = loadedPin.find('h1').html();
				pin.sub_heading = loadedPin.find('h2').html();
				pin.address = loadedPin.find('.address').html();
				pin.phone = loadedPin.find('.phone').html();
				pin.content = loadedPin.find('.content').html();
				pin.x = parseInt(loadedPin.attr('data-x'));
				pin.y = parseInt(loadedPin.attr('data-y'));
				
				pinEl.css({
					"position" : 'absolute',
					"left" : pin.x * ratio,
					"top" : pin.y * ratio
				});
				
				appendContents(pinEl);
				
				pinEl.find('h1').html(pin.main_heading);
				pinEl.find('h2').html(pin.sub_heading);
				pinEl.find('.address').html(pin.address);
				pinEl.find('.phone').html(pin.phone);
				pinEl.find('.content').html(pin.content);
				
				pinEl.data({
					"init" : true,
					"x" : pin.x,
					"y" : pin.y
				});
				
				setEventsForPin(pinEl);
				
				pins['pin-'+pinId] = pin;
				pinId++;
			}
		}
		function setEventsForPin(pinEl) {
			$(pinEl).find('.close').on('click', function() {
				$(this).closest('.pin-wrap').removeClass('selected');
			});

			$(pinEl).find('.delete').on('click', function() {
				deletePin($(this).closest('.pin-wrap'));
			});

			$(pinEl).find('.pin').on('click', function(e) {
				e.preventDefault();
				$('.selected').removeClass('selected');
				$(this).parent().addClass('selected');
				updateForm();
				updateData();
				return false;
			});
			$(pinEl).on('mousedown', function(e) {
				e.preventDefault();
				dragging = true;
				dragTarget = $(this);
				ix = $(this).position().left;
				iy = $(this).position().top;
				ex = e.pageX;
				ey = e.pageY;
				
				return false;
			});

			$(pinEl).find('.pin-contents').css({
				"top" : -$(pinEl).find('.pin-contents').height() - 80
			});
		}
		function deletePin(pin) {
			pins[pin.attr('id')] = undefined;
			pin.remove();
		}
		function dropPinToMap(pin, e) {
			pin.data({
				"init" : true,
				"x" : pin.position().left,
				"y" : pin.position().top
			});
			
			appendContents(pin);
			
			setEventsForPin(pin);

			pins[pin.attr('id')].title = pin.attr('data-title');
			pins[pin.attr('id')].main_heading = pin.find('h1').html();
			pins[pin.attr('id')].sub_heading = pin.find('h2').html();
			pins[pin.attr('id')].address = pin.find('.address').html();
			pins[pin.attr('id')].phone = pin.find('.phone').html();
			pins[pin.attr('id')].content = pin.find('.content').html();
		}
		function result() {
			var html='';
			
			html += "<div id=\"rockstar-map\">\n";
			var pin;

			for (var i=0; i<pinId; i++) {
				pin = pins['pin-'+i];
				
				if (pin != undefined) {
													  html += "\t<div class=\"location\" id=\"loc-"+i+"\" data-title=\""+pin.title+"\" data-x=\""+pin.x+"\" data-y=\""+pin.y+"\">\n";
					if (pin.main_heading != undefined) 	{ html += "\t\t<h1>"+pin.main_heading+"</h1>\n"; }
					if (pin.sub_heading != undefined) 		{ html += "\t\t<h2>"+pin.sub_heading+"</h2>\n"; }
					if (pin.address != undefined) 			{ html += "\t\t<p class=\"address\">"+pin.address+"</p>\n"; }
					if (pin.phone != undefined) 			{ html += "\t\t<p class=\"phone\">"+pin.phone+"</p>\n"; }
					if (pin.content != undefined) 			{ html += "\t\t<p class=\"content\">"+pin.content+"</p>\n"; }
													  html += "\t</div>\n";
				}
				
			}
			
			html += "</div>";
			
			return html;
		}
		function updateForm() {
			var id = $('.selected').attr('id');
			$('#title').val(pins[id].title);
			$('#main_heading').val(pins[id].main_heading);
			$('#sub_heading').val(pins[id].sub_heading);
			$('#address').val(pins[id].address);
			$('#phone').val(pins[id].phone);
			$('#content').val(pins[id].content);
		}
		function updateCoords(el) {
			var id = el.attr('id');
			pins[id].x = pins[id].el.position().left / ratio;
			pins[id].y = pins[id].el.position().top / ratio;
		} 
		function updateData() {
			var id = $('.selected').attr('id');
			pins[id].title = $('#title').val();
			pins[id].main_heading = $('#main_heading').val();
			pins[id].sub_heading = $('#sub_heading').val();
			pins[id].address = $('#address').val();
			pins[id].phone = $('#phone').val();
			pins[id].content = $('#content').val();
			
			$('.selected').find('h1').html(pins[id].main_heading);
			$('.selected').find('h2').html(pins[id].sub_heading);
			$('.selected').find('.address').html(pins[id].address);
			$('.selected').find('.phone').html(pins[id].phone);
			$('.selected').find('.content').html(pins[id].content);
			
			if (pins[id].main_heading == '') {
				$('.selected').find('h1').hide();
			} else { 
				$('.selected').find('h1').show(); 
			}
			
			if (pins[id].sub_heading == '') {
				$('.selected').find('h2').hide();
			} else { 
				$('.selected').find('h2').show(); 
			}
			
			if (pins[id].address == '') {
				$('.selected').find('.address').hide();
			} else { 
				$('.selected').find('.address').show(); 
			}
			
			if (pins[id].phone == '') {
				$('.selected').find('.phone').hide();
			} else { 
				$('.selected').find('.phone').show(); 
			}
			
			if (pins[id].content == '') {
				$('.selected').find('.content').hide();
			} else { 
				$('.selected').find('.content').show(); 
			}
			
			$('.selected').find('.pin-contents').css({
				"top" : -$('.selected').find('.pin-contents').height() - 80
			});
		}
		function pinHtml() {
			var ph='';

			ph += '<div class="pin-wrap" id="pin-'+pinId+'" data-title="Pin Title">';
			ph += 	'<div class="pin"></div>';
			ph += '</div>';
			
			return ph;
		}
		function appendContents(pin) {
			var ph='';
			ph += 	'<div class="pin-contents">';
			ph += 		'<div class="delete"></div>';
			ph += 		'<div class="close"></div>';
			ph += 		'<h1>Main Heading</h1>';
			ph += 		'<h2>Sub Heading</h2>';
			ph += 		'<p class="address">13 Random Str. 9000<br />Second line address</p>';
			ph += 		'<p class="phone">+359 876 122011<br />+359 882 109953<br />+359 872 121010</p>';
			ph += 		'<p class="content">';
			ph += 		'	Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.';
			ph += 		'</p>';
			ph += 	'</div>';
			pin.append(ph);
		}
		function isWithinArea(x, y, a) {
			if ((x > a.offset().left && x < a.offset().left + a.width()) &&
				(y > a.offset().top && y < a.offset().top + a.height())) {
				return true;
			}
			return false;
		}
	});
}(jQuery));